<%-- $Id: edit_client.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.CLIENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Client client = null;

	if (itemId == 0)
	{
		title = "Create client application";
		cc.removeObject("item");
	}
	else
	{
		client = Client.getById(dc, itemId);
		cc.setObject("item", client);
		title = "Edit client application -- " + HTML.encodeTags(client.getName());
	}
	if (client != null && !client.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), client);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Client" tab
		function validateClient()
		{
			var frm = document.forms['client'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['client'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (client == null)
			{
				%>
				var frm = document.forms['client'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="client" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=client != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Client application" validate="validateClient()" helpid="client.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(client == null ? Values.getString(cc.getPropertyValue("name"), "New client application") : client.getName())%>" 
					maxlength="<%=Client.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External Id</th>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(client == null ? cc.getPropertyValue("externalId") : client.getExternalId())%>" 
					maxlength="<%=Client.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(client == null ? cc.getPropertyValue("description") : client.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'client', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
