<%-- $Id: edit_help.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.Help"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
final Item itemType = Item.HELP;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int clientId = Values.getInt(request.getParameter("client_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Client client = null;
	Help help = null;
	String externalId = null;
	
	if (itemId == 0)
	{
		title = "Create help";
		cc.removeObject("item");
		client = Client.getById(dc, clientId);
		externalId = Values.getString(request.getParameter("external_id"), 
			cc.getPropertyValue("externalId"));
	}
	else
	{
		help = Help.getById(dc, itemId);
		cc.setObject("item", help);
		title = "Edit help text -- " + HTML.encodeTags(help.getName());
		externalId = help.getExternalId();
	}
	if (help != null) help.checkPermission(Permission.WRITE);
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), help);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="menu.js,tabcontrol.js" styles="toolbar.css,tabcontrol.css,menu.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Help" tab
		function validateHelp()
		{
			var frm = document.forms['help'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['help'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
	
		function init()
		{
			var frm = document.forms['help'];
			<%
			if (help == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		
		/*
			Enclose the selected text with prefix and suffix. Code taken
			from Trac: http://projects.edgewall.com/trac/
		*/
		function encloseSelection(prefix, suffix)
		{
			var frm = document.forms['help'];
			var textarea = frm.description;
			textarea.focus();
		    var start, end, sel, scrollPos, subst;
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      sel = document.selection.createRange().text;
		    } 
		    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
		    {
		      start = textarea.selectionStart;
		      end = textarea.selectionEnd;
		      scrollPos = textarea.scrollTop;
		      sel = textarea.value.substring(start, end);
		    }
		    if (sel.match(/ $/)) 
		    { 
		    	// exclude ending space char, if any
		      	sel = sel.substring(0, sel.length - 1);
		      	suffix = suffix + " ";
		    }
		    subst = prefix + sel + suffix;
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      var range = document.selection.createRange().text = subst;
		      textarea.caretPos -= suffix.length;
		    } 
		    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
		    {
		      textarea.value = textarea.value.substring(0, start) + subst +
		                       textarea.value.substring(end);
		      if (sel) 
		      {
		        textarea.setSelectionRange(start + subst.length, start + subst.length);
		      } 
		      else 
		      {
		        textarea.setSelectionRange(start + prefix.length, start + prefix.length);
		      }
		      textarea.scrollTop = scrollPos;
		    }
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<m:menu
			id="listtype"
			style="display: none;">			
		<m:menuitem 
			title="Ordered list" 
			onclick="encloseSelection('&lt;ol&gt;', '&lt;/ol&gt;')"
			tooltip="Insert an ordered list"
		/>
		<m:menuitem
			title="Unordered list"
			onclick="encloseSelection('&lt;ul&gt;', '&lt;/ul&gt;')"
			tooltip="Insert an unordered list"
		/>			
		<m:menuitem
			title="List item"
			onclick="encloseSelection('&lt;li&gt;', '&lt;/li&gt;')"
			tooltip="Insert a listitem."
		/>			
		</m:menu>
		<%
		String tableInsert = "encloseSelection('&lt;table frame=&quot;borders&quot;&gt;', '&lt;/table&gt;')";
		%>
		<m:menu
			id="tableitem"
			style="display: none;">
		<m:menuitem
			title="Table"
			onclick="<%=tableInsert%>"
			tooltip="Insert a table"
		/>
		<m:menuitem
			title="Row"
			onclick="encloseSelection('&lt;tr&gt;', '&lt;/tr&gt;')"
			tooltip="Insert a tablerow."
		/>
		<m:menuitem
			title="Cell"
			onclick="encloseSelection('&lt;td&gt;', '&lt;/td&gt;')"
			tooltip="Insert a datacell."
		/>
		</m:menu>
		<m:menu
			id="textformats"
			style="display: none;">
		<m:menuitem
			title="Important"
			onclick="encloseSelection('&lt;imp&gt;', '&lt/imp&gt;')"
			tooltip="Mark text as important"
		/>
		<m:menuitem
			title="Label"
			onclick="encloseSelection('&lt;lbl&gt;', '&lt/lbl&gt;')"
			tooltip="Mark text as a label appearing in the interface."
		/>
		<m:menuitem
			title="Required"
			onclick="encloseSelection('&lt;req&gt;', '&lt/req&gt;')"
			tooltip="Mark text as required user input."
		/>
		<m:menuitem
			title="Button text"
			onclick="encloseSelection('&lt;btn&gt;', '&lt/btn&gt;')"
			tooltip="Mark text to symbol a button."
		/>
		<m:menuitem
			title="Menu text"
			onclick="encloseSelection('&lt;mnu&gt;', '&lt/mnu&gt;')"
			tooltip="Mark text to symbol a menu."
		/>
		</m:menu>		
		<m:menu
			id="link"
			style="display: none;"
		>
		<m:menuitem
			title="Insert helptext"
			onclick="encloseSelection('{@include ', '}')"
			tooltip="Insert another helptext in this text."
		/>		
		<m:menuitem
			title="Internal link"
			onclick="encloseSelection('{@link ', '}')"
			tooltip="Insert a link to another help topic."
		/>
		<%
		String insertBookmarkLink = "encloseSelection('&lt;a href=&quot;#&quot&gt;', '&lt/a&gt;')";
		%>
		<m:menuitem
			title="External link"
			onclick="<%=insertBookmarkLink%>"
			tooltip="Insert a link to an external web page."
		/>
		<%
		String insertBookmark = "encloseSelection('&lt;a&nbsp;name=&quot;&quot;&gt;', '&lt;/a&gt;')";
		%>
		<m:menuitem
			title="Bookmark"
			onclick="<%=insertBookmark%>"
			tooltip="Insert a bookmark"
		/>
		</m:menu>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="help" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="client_id" value="<%=clientId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=help != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Help text" validate="validateHelp()" helpid="help.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Title</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(help == null ? Values.getString(cc.getPropertyValue("name"), "New help") : help.getName())%>" 
					maxlength="<%=Help.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(externalId)%>"
					maxlength="<%=Help.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>		
			<tr>
				<th>Help text</th>
				<td colspan="2" style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder topborder">												
						<tbl:button 
							tooltip="Bold"							
							image="text_bold.png"
							onclick="encloseSelection('&lt;b&gt;', '&lt;/b&gt;')"
						/>
						<tbl:button
							tooltip="Italic"							
							image="text_italic.png"
							onclick="encloseSelection('&lt;i&gt;', '&lt;/i&gt;')"
						/>
						<tbl:button
							tooltip="Underline"
							image="text_underline.png"
							onclick="encloseSelection('&lt;u&gt;', '&lt;/u&gt;')"
						/>											
						<tbl:button
							tooltip="Header 3"
							image="text_h3.png"
							onclick="encloseSelection('&lt;h3&gt;', '&lt;/h3&gt;')"
						/>
						<tbl:button
							tooltip="Header 4"
							image="text_h4.png"
							onclick="encloseSelection('&lt;h4&gt;', '&lt;/h4&gt;')"
						/>
						<tbl:button
							tooltip="Textstyle"
							image="text_style_edit.png"
							onclick="Menu.toggleTopMenu(document.getElementById('textformats'), event.clientX, event.clientY); event.cancelBubble = true;"
						/>						
						<tbl:button
							tooltip="Table"
							image="text_table.png"
							onclick="Menu.toggleTopMenu(document.getElementById('tableitem'), event.clientX, event.clientY); event.cancelBubble = true;"
						/>
						<tbl:button
							tooltip="List"
							image="text_list.gif"
							onclick="Menu.toggleTopMenu(document.getElementById('listtype'), event.clientX, event.clientY); event.cancelBubble = true;"
						/>
						<tbl:button
							tooltip="New line"
							image="text_newline.gif" 
							onclick="encloseSelection('&lt;br&gt;', '')"
						/>
						<tbl:button
							tooltip="New paragraph"
							image="text_paragraph.gif"
							onclick="encloseSelection('&lt;p&gt;', '&lt;/p&gt;')"
						/>			
						<tbl:button
							tooltip="New link"
							image="text_link.png"							
							onclick="Menu.toggleTopMenu(document.getElementById('link'), event.clientX, event.clientY); event.cancelBubble = true;"
						/>					
					</tbl:toolbar>
				</td>
			</tr>
			<tr class="dynamic">
				<th class="subprompt"></th>
				<td>
					<textarea <%=clazz%> rows="16" name="description" 
						><%=HTML.encodeTags(help == null ? cc.getPropertyValue("description") : help.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Help text', 'help', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
