<%-- $Id: edit_hardware.jsp 6058 2012-06-13 07:41:53Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.HARDWARE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Hardware hardware = null;
	boolean readCurrentSubtype = true;
	int currentSubtypeId = 0;

	if (itemId == 0)
	{
		title = "Create hardware";
		cc.removeObject("item");
		currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		if (currentSubtypeId == 0)
		{
			int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
			currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
		}
	}
	else
	{
		hardware = Hardware.getById(dc, itemId);
		hardware.checkPermission(Permission.WRITE);
		cc.setObject("item", hardware);
		title = "Edit hardware -- " + HTML.encodeTags(hardware.getName());
		try
		{
			ItemSubtype subtype = hardware.getItemSubtype();
			if (subtype != null) currentSubtypeId = subtype.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
	}
	
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), hardware);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,ajax.js,json2.js,subtypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Hardware" tab
		function validateHardware()
		{
			var frm = document.forms['hardware'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['hardware'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (hardware == null)
			{
				%>
				var frm = document.forms['hardware'];
				frm.name.focus();
				frm.name.select();
				subtypeOnChange();
				<%
			}
			%>
		}
		function subtypeOnChange()
		{
			var frm = document.forms['hardware'];
			if (frm.replaceExistingDefault)
			{
				var subtypeId = ItemSubtype.getSubtypeId('hardware');
				var defaultInfo = ItemSubtype.getRecentAndDefaultInfo(subtypeId, 'HARDWARE');
				var currentDefaultDiv = document.getElementById('currentDefault');
				
				var tooltip = '';
				var html = '';
				var checked = true;
				var disabled = false;
				
				var numDefaults = defaultInfo['default'] ? defaultInfo['default'].length : 0;
				if (numDefaults == 1)
				{
					html = '('+Main.encodeTags(Main.cutString(defaultInfo['default'][0].name, 40)) + ')';
				}
				else if (numDefaults == 0)
				{
					html = '(-none-)';
					checked = false;
					disabled = true;
				}
				else
				{
					html = '(' + numDefaults + ' different)';
					for (var i = 0; i < numDefaults; i++)
					{
						tooltip += Main.encodeTags(defaultInfo['default'][i].name) + '\n';
					}
					checked = false;
				}
				
				currentDefaultDiv.title = tooltip;
				currentDefaultDiv.innerHTML = html;
				frm.replaceExistingDefault.checked = checked;
				frm.replaceExistingDefault.disabled = disabled;
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="hardware" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=hardware != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Hardware" validate="validateHardware()" helpid="hardware.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(hardware == null ? Values.getString(cc.getPropertyValue("name"), "New hardware") : hardware.getName())%>" 
					maxlength="<%=Hardware.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id" 
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						onchange="subtypeOnChange()"
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && hardware != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Version</th>
				<td><input <%=clazz%> type="text" name="version" 
					value="<%=HTML.encodeTags(hardware == null ? cc.getPropertyValue("versionString") : hardware.getVersionString())%>" 
					maxlength="<%=Hardware.MAX_VERSIONSTRING_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(hardware == null ? cc.getPropertyValue("description") : hardware.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'hardware', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			<%
			if (sc.getActiveProjectId() != 0 && hardware == null && sc.getActiveProjectPermissions().contains(Permission.WRITE))
			{
				%>
				<tr>
					<th></th>
					<td style="white-space: nowrap; overflow: hidden; padding-bottom: 2px;">
						<input type="checkbox" id="setAsProjectDefault" name="setAsProjectDefault" value="1" 
							checked><label for="setAsProjectDefault">Add as project default</label><br>
						<input type="checkbox" id="replaceExistingDefault" name="replaceExistingDefault" value="1"
							checked><label for="replaceExistingDefault">Replace existing default</label>
							<span id="currentDefault" style="font-style: italic;"></span>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
