<%-- $Id: edit_configuration.jsp 6021 2012-03-19 09:59:41Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLUGINCONFIGURATION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PluginConfiguration configuration = null;
	PluginDefinition currentPlugin = null;
	PluginConfiguration originalConfiguration = null;
	PluginDefinition originalCurrentPlugin = null;
	boolean readCurrentPlugin = true;
	String name = null;
	String description = null;
	
	// Load recently used items
	List<PluginDefinition> recentPlugins = (List<PluginDefinition>)cc.getRecent(dc, Item.PLUGINDEFINITION);

	if (itemId == 0)
	{
		title = "Create configuration";
		cc.removeObject("item");
		int pluginId = Values.getInt(request.getParameter("plugindefinition_id"));
		if (pluginId != 0)
		{
			currentPlugin = PluginDefinition.getById(dc, pluginId);
		}
		else if (cc.getPropertyFilter("pluginDefinition.name") != null)
		{
			currentPlugin = Base.getFirstMatching(dc, PluginDefinition.getQuery(), "name", cc.getPropertyFilter("pluginDefinition.name"));
		}
		if (currentPlugin != null)
		{
			name = "New " + currentPlugin.getName() + " configuration";
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New configuration");
		}
		description = cc.getPropertyValue("description");
	}
	else if ("CopyItem".equals(request.getParameter("cmd")))
	{
		originalConfiguration = PluginConfiguration.getById(dc, itemId);
		cc.removeObject("item");
		title = "Create configuration";
		name = "Copy of " + originalConfiguration.getName();
		description = originalConfiguration.getDescription();
		try
		{
			currentPlugin = originalConfiguration.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPlugin = false;
		}
	}
	else
	{
		configuration = PluginConfiguration.getById(dc, itemId);
		cc.setObject("item", configuration);
		title = "Edit configuration -- " + HTML.encodeTags(configuration.getName());
		name = configuration.getName();
		description = configuration.getDescription();
		try
		{
			currentPlugin = configuration.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPlugin = false;
		}
	}
	if (configuration != null) configuration.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), configuration);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Configuration" tab
		function validateConfiguration()
		{
			var frm = document.forms['configuration'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (frm.plugindefinition_id && frm.plugindefinition_id[frm.plugindefinition_id.selectedIndex].value == 0)
			{
				alert("You must select a plugin");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings(configure)
		{
			var frm = document.forms['configuration'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				frm.configure.value = configure;
				frm.submit();
			}
		}

		var annotationsLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
					annotationsLoaded = true;
				}
			}
		}
		
		function init()
		{
			<%
			if (configuration == null)
			{
				%>
				var frm = document.forms['configuration'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		function selectPluginOnClick()
		{
			var frm = document.forms['configuration'];
			var url = '../plugindefinitions/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPluginCallback';
			url += '&resetTemporary=1&tmpfilter:BOOLEAN:supportsConfigurations=true';
			<%
			if (configuration == null)
			{
				String pluginMainType = Values.getStringOrNull(request.getParameter("plugin.mainType"));
				String pluginItemType = Values.getStringOrNull(request.getParameter("plugin.itemType"));
				if (pluginMainType != null)
				{
					%>
					url += '&tmpfilter:INT:mainType=<%=Plugin.MainType.valueOf(pluginMainType).getValue()%>';
					<%
				}
				if (pluginItemType != null)
				{
					%>
					url += '&tmpfilter:INT:$ctx.itemType=<%=Item.valueOf(pluginItemType).getValue()%>';
					<%
				}
			}
			%>
			if (frm.plugindefinition_id.length > 0) url += '&item_id='+frm.plugindefinition_id[0].value;
			Main.openPopup(url, 'SelectPluginDefinition', 1050, 700);
		}
		function setPluginCallback(id, name)
		{
			var frm = document.forms['configuration'];
			var list = frm.plugindefinition_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}

		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="configuration" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="configure" value="0">
		<input type="hidden" name="copyfrom" value="<%=originalConfiguration != null ? originalConfiguration.getId() : 0%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=configuration != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Configuration" validate="validateConfiguration()" helpid="pluginconfiguration.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Plugin</th>
				<td>
					<%
					if (configuration == null)
					{
						%>
						<base:select 
							id="plugindefinition_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentPlugin%>"
							recent="<%=recentPlugins%>"
							newitem="true"
							onselect="selectPluginOnClick()"
						/>
						<%
					}
					else
					{
						%>
						<%=currentPlugin == null ? "<i>- denied -</i>" : HTML.encodeTags(currentPlugin.getName())%>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=PluginConfiguration.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(description)%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'configuration', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			helpid="annotations.edit" tooltip="Enter values for annotations"
			visible="<%=currentPlugin != null && currentPlugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin")%>"><iframe 
			name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
			style="width: 100%; height: 100%;"></iframe></t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings(0)" title="Save" />
			<base:button onclick="saveSettings(1)" 
				image="runplugin.png" title="Save and configure" 
				visible="<%=currentPlugin == null || currentPlugin.supportsConfigurations()%>" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
