<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtensionsFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.Registry"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.service.ServiceControllerAction"
	import="net.sf.basedb.clients.web.extensions.service.Services"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
String cmd = request.getParameter("cmd");

DbControl dc = sc.newDbControl();

JspContext jspContext = ExtensionsControl.createContext(dc, pageContext);
ExtensionsInvoker<ServiceControllerAction> invoker = 
	(ExtensionsInvoker<ServiceControllerAction>)ExtensionsControl.useExtensions(jspContext, 
	(ExtensionsFilter)null, Services.EXTENSION_POINT_ID);
ExtensionsControl ec = ExtensionsControl.get(dc);
boolean writePermission = ec.hasPermission(Permission.WRITE);
ActionIterator<ServiceControllerAction> it = invoker.iterate();
int numServices = 0;

try
{
	%>
	<base:page title="Manage Services">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css">
	<script language="javascript">
	function stop(extensionId)
	{
		location.href = 'index.jsp?ID=<%=ID%>&cmd=Stop&extensionId=' + extensionId;
	}
	function start(extensionId)
	{
		location.href = 'index.jsp?ID=<%=ID%>&cmd=Start&extensionId=' + extensionId;
	}
	function toggleStacktrace(evt, extensionId)
	{
		Main.showHide('stacktrace.' + extensionId);
	}
	</script>
	</base:head>
	<base:body>
	<h1>Manage Services</h1>
	<div class="content">
		<tbl:table 
			id="services"
			subclass="fulltable topborder"
			columns="all"
			>
			<tbl:columndef 
				id="extension"
				title="Extension" 
			/>
			<tbl:columndef 
				id="service"
				title="Service" 
			/>
			<tbl:columndef 
				id="status"
				title="Status" 
			/>
			<tbl:columndef 
				id="actions"
				title="Actions" 
			/>
			<tbl:data style="top: 0px;  margin-top: 0px;">
				<tbl:headers>
					<tbl:headerrow>
						<tbl:columnheaders />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
				<%
				Extension last = null;
				while (it.hasNext())
				{
					numServices++;
					ServiceControllerAction action = it.next();
					Extension ext = it.getExtension();
					boolean isNewExtension = ext != last;
					last = ext;
					boolean isRunning = action.isRunning();
					Throwable error = ec.getLastExtensionError(ext.getId());
					boolean hasError = error != null;
					%>
					<tbl:row>
						<tbl:cell column="extension">
							<%
							if (isNewExtension)
							{
								%>
								<%=ext.getId()%>
								<%
							}
							%>
							</tbl:cell>
						<tbl:cell column="service"><%=action.toString()%></tbl:cell>
						<tbl:cell column="status">
							<%
							if (hasError)
							{
								%>
								<div class="messagecontainer error">
								<base:icon image="error.png" 
										onclick="<%="toggleStacktrace(event, '" + ext.getId() + "')"%>" 
										style="float: left;"
										tooltip="Error - click to show full stack trace"
								/><%=error.getMessage() %>
								<div id="stacktrace.<%=ext.getId()%>"
										class="stacktrace"
										style="display: none;"
									><%=ThrowableUtil.stackTraceToString(error)%></div>
								</div>
								<%
							}
							else
							{
								%>
								<%=isRunning ? "Running" : "Stopped"%>
								<%
							}
							%>
						</tbl:cell>
						<tbl:cell column="actions">
							<%
							if (isNewExtension && writePermission)
							{
								if (isRunning)
								{
									%>
									<base:icon 
										image="stop.png" 
										onclick="<%="stop('" + ext.getId() + "')"%>" 
										tooltip="Stop all services in this extension"
									/>
									<%
								}
								else
								{
									%>
									<base:icon 
										image="start.png" 
										onclick="<%="start('" + ext.getId() + "')"%>" 
										tooltip="Start all services in this extension"
									/>
									<%
								}
							}
							%>
						</tbl:cell>
					</tbl:row>
					<%
				}
				if (numServices == 0)
				{
					%>
					<tbl:panel clazz="messagepanel">
						<div class="messagecontainer note">No services are installed</div>
					</tbl:panel>	
					<%
				}
				%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
