<%-- $Id: edit_biowell.jsp 5977 2012-02-20 13:26:26Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final Item itemType = Item.BIOWELL;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioWell bioWell = BioWell.getById(dc, itemId);
	BioPlate bioPlate = bioWell.getPlate();
	BioPlateType bioPlateType = bioPlate.getBioPlateType();
	Item bioMaterialType = bioPlateType.getBioMaterialType();
	ItemSubtype bioMaterialSubType = bioPlateType.getItemSubtype();
	
	bioWell.checkPermission(Permission.WRITE);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	title = "Edit biowell -- " + rowFormatter.format(bioWell.getRow()) + columnFormatter.format(bioWell.getColumn()) + " on " + HTML.encodeTags(bioPlate.getName());

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	
	boolean readCurrentBioMaterial = true;
	MeasuredBioMaterial currentBioMaterial = null;
	try
	{
		currentBioMaterial = bioWell.getBioMaterial();
	}
	catch (PermissionDeniedException ex)
	{
		readCurrentBioMaterial = false;
	}
	boolean canAddBioMaterial = bioWell.canAddBioMaterial();

	cc.setObject("item", bioWell);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioWell);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "BioWell" tab
		function validateBioWell()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['biowell'];
			if (validateBioWell())
			{
				frm.biomaterial_type.disabled = false;
				frm.submit();
			}
		}

		// Biomaterial selection
		function selectBioMaterialOnClick()
		{
			var frm = document.forms['biowell'];
			var typelist = frm.biomaterial_type;			
			if (typelist.selectedIndex == 0)
			{
				alert("You must first select what type of biomaterial");
				return;
			}			
			var type = typelist[typelist.selectedIndex].value;
			var folder = type.toLowerCase();		
			var controller = Main.getController(type);
			var url = getRoot() + controller.url + '?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioMaterialCallback';
			if (frm.biomaterial_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.biomaterial_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:STRING:bioWell='+escape('=');
			<%
			if (bioMaterialSubType != null)
			{
				%>
				url += '&tmpfilter:INT:itemSubtype=<%=bioMaterialSubType.getId()%>';
				<%
			}
			%>
			Main.openPopup(url, 'Select'+type, 1050, 700);
		}
		function setBioMaterialCallback(id, name)
		{
			var frm = document.forms['biowell'];
			var list = frm.biomaterial_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function bioMaterialTypeOnChange()
		{
			var frm = document.forms['biowell'];
			var list = frm.biomaterial_id;
			list.selectedIndex = 0;
			list.remove(1);
		}
		</script>
	</base:head>
	<base:body>
		<h1><%=title%> <base:help helpid="biowell.edit" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="biowell" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<div class="content bottomborder">

			<table class="fullform input100">
			<tr>
				<th>Bioplate</th>
				<td><%=HTML.encodeTags(bioPlate.getName())%></td>
			</tr>
			<tr>
				<th>Well location</th>
				<td><%=rowFormatter.format(bioWell.getRow())%><%=columnFormatter.format(bioWell.getColumn())%></td>
			</tr>
			<tr>
				<th>Biomaterial type</th>
				<td>					
					<select name="biomaterial_type" onchange="bioMaterialTypeOnChange()" <%=bioMaterialType != null ? "disabled": ""%>>
						<%
						if (!readCurrentBioMaterial)
						{
							%>
							<option value="-1">- denied -
							<%
						}
						else
						{
							Item currentBmType = currentBioMaterial == null ? null : currentBioMaterial.getType();
							String subtype = bioMaterialSubType != null ? " ("+HTML.encodeTags(bioMaterialSubType.getName()) + ")" : "";
							%>
							<option value="0">- none -
							<option value="<%=Item.SAMPLE.name()%>" 
								<%=currentBmType == Item.SAMPLE || bioMaterialType == Item.SAMPLE ? "selected" : ""%>>Sample<%=subtype %>
							<option value="<%=Item.EXTRACT.name()%>" 
								<%=currentBmType == Item.EXTRACT || bioMaterialType == Item.EXTRACT ? "selected" : ""%>>Extract<%=subtype %>
							<%
						}
						%>
					</select>
				</td>
			</tr>
			<tr>
				<th>Biomaterial</th>
				<td>
					<base:select 
						id="biomaterial_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioMaterial%>"
						denied="<%=!readCurrentBioMaterial%>"
						recent="<%=null%>"
						newitem="<%=false%>"
						onselect="<%=canAddBioMaterial ? "selectBioMaterialOnClick()" : null%>"
					/>
				</td>
			</tr>
			<%
			if (!canAddBioMaterial && currentBioMaterial != null)
			{
				%>
				<tr>
					<th></th>
					<td>
						<div class="messagecontainer note">
							New biomaterial can't be added to this well if 
							'<%=HTML.encodeTags(currentBioMaterial.getName())%>' is removed.
						</div>
					</td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
