<%-- $Id: view_extract.jsp 6053 2012-05-03 07:27:21Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.CommonItem"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemProxy"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.SpecialQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.EXTRACT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

	String title = null;
	Extract extract = Extract.getById(dc, itemId);
	BioMaterialEvent creationEvent = extract.getCreationEvent();
	
	final boolean writePermission = extract.hasPermission(Permission.WRITE);
	final boolean deletePermission = extract.hasPermission(Permission.DELETE);
	final boolean sharePermission = extract.hasPermission(Permission.SET_PERMISSION);
	final boolean usePermission = extract.hasPermission(Permission.USE);
	final boolean setOwnerPermission = extract.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = extract.isRemoved();
	final boolean isUsed = isRemoved && extract.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = extract.isOwner();	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, extract);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function newExtract()
		{
			Main.viewOrEditItem('<%=ID%>', 'EXTRACT', 0, true, '&extract_id=<%=itemId%>');
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareExtract', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 300);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 750, 500);
		}
		function viewEvents()
		{
			location.href = '../events/index.jsp?ID=<%=ID%>&cmd=List&biomaterial_id=<%=itemId%>&biomaterial_type=<%=itemType.name()%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if ((tabId == 'overview' || tabId == 'history') && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'events')
			{
				viewEvents();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newPhysicalBioAssay()
		{
			Main.viewOrEditItem('<%=ID%>', 'PHYSICALBIOASSAY', 0, true, '&extract_id='+<%=itemId%>);
		}
		function newRawBioAssay()
		{
			Main.viewOrEditItem('<%=ID%>', 'RAWBIOASSAY', 0, true, '&extract_id='+<%=itemId%>);
		}
		</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Extracts" href="<%="index.jsp?ID="+ID%>" /><p:pathelement
			title="<%=HTML.encodeTags(extract.getName())%>" /></p:path>
		
		<t:tabcontrol id="main" subclass="content mastertabcontrol" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=extract.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						image="deleted.png"
						onclick="deleteItemPermanently()"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon image="used.png" 
						onclick="showUsingItems()"
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							onclick="editItem()" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this extract" : "You do not have permission to edit this extract"%>" 
						/>
						<tbl:button 
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							onclick="deleteItem()" 
							title="Delete"
							visible="<%=!extract.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this extract" : "You do not have permission to delete this extract"%>" 
						/>
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							onclick="restoreItem()" 
							title="Restore"
							visible="<%=extract.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this extract" : "You do not have permission to restore this extract"%>" 
						/>
						<tbl:button 
							disabled="<%=!sharePermission%>"
							image="share.png"
							onclick="shareItem()" 
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this extract to other user, groups and projects" : "You do not have permission to share this extract"%>"
						/>
						<tbl:button 
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							onclick="setOwner()" 
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button
							image="add.png"
							onclick="newExtract()"
							title="New child extract&hellip;"
							tooltip="Create a new child extract from this extract"
							visible="<%=sc.hasPermission(Permission.CREATE, Item.EXTRACT) && usePermission%>"
						/>
						<tbl:button
							image="add.png"
							onclick="newPhysicalBioAssay()"
							title="New physical bioassay&hellip;"
							tooltip="Create a new physical bioassay from this extract"
							visible="<%=sc.hasPermission(Permission.CREATE, Item.PHYSICALBIOASSAY) && usePermission%>"
						/>
						<tbl:button
							image="add.png"
							onclick="newRawBioAssay()"
							title="New raw bioassay&hellip;"
							tooltip="Create a new raw bioassay from this extract"
							visible="<%=sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY) && usePermission%>"
						/>
						<tbl:button 
							image="import.png" 
							onclick="runPlugin('ImportItem')" 
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							image="export.png" 
							onclick="runPlugin('ExportItem')" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							image="runplugin.png" 
							onclick="runPlugin('RunPlugin')" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							onclick="<%="Main.openHelp('" + ID +"', 'extract.view.properties')"%>"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
						</tbl:toolbar>
					</td>
				</tr>
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(extract.getName())%></td>
				</tr>
				<tr>
					<th>Type</th>
					<td><base:propertyvalue item="<%=extract%>" property="itemSubtype" /></td>
				</tr>
				<tr>
					<th>External ID</th>
					<td><%=HTML.encodeTags(extract.getExternalId())%></td>
				</tr>
				<tr>
					<th>Created</th>
					<td><%=dateFormatter.format(creationEvent.getEventDate())%></td>
				</tr>
				<tr>
					<th>Registered</th>
					<td><%=dateFormatter.format(creationEvent.getEntryDate())%></td>
				</tr>
				<tr>
					<th>Tag</th>
					<td><base:propertyvalue item="<%=extract%>" property="tag"/></td>
				</tr>
				<tr>
					<th>Protocol</th>
					<td><base:propertyvalue item="<%=creationEvent%>" property="protocol"/></td>
				</tr>
				<tr>
					<th>Original quantity</th>
					<td><%=Values.formatNumber(extract.getOriginalQuantity(), 2, " µg")%></td>
				</tr>
				<tr>
					<th class="subprompt">- remaining</th>
					<td><%=Values.formatNumber(extract.getRemainingQuantity(), 2, " µg")%></td>
				</tr>
				<tr>
					<th>Bioplate</th>
					<td>
						<base:propertyvalue item="<%=extract%>" property="bioWell.bioPlate" />
						<%
						try
						{
							BioWell well = extract.getBioWell();
							if (well != null)
							{
								%>
								[<%=rowFormatter.format(well.getRow())%><%=columnFormatter.format(well.getColumn())%>]
								<base:icon image="locked.png"  visible="<%=extract.isLockedInWell()%>"/>
							<%
							}
						}
						catch (PermissionDeniedException ex)
						{}
						%>
					</td>
				</tr>
				<tr>
					<th>Owner</th>
					<td><base:propertyvalue item="<%=extract%>" property="owner"/></td>
				</tr>
				<tr>
					<th>Permissions</th>
					<td><%=PermissionUtil.getFullPermissionNames(extract)%></td>
				</tr>
				<tr>
					<th>Description</th>
					<td><%=HTML.niceFormat(extract.getDescription())%></td>
				</tr>
			</table>
			</div>
	
			<%
			SpecialQuery<BioMaterialEventSource> sourceQuery = creationEvent.getEventSources();
			sourceQuery.order(Orders.asc(Hql.property("bioMaterial.name")));
			ResultList<BioMaterialEventSource> sources = sourceQuery.list(dc);
			%>
			<base:section 
				id="parentsSection" 
				title="<%="Parent items (" + sources.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (sources.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This extract doesn't have any parent items
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="parents"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="type"
						title="Type"
					/>
					<tbl:columndef 
						id="quantity"
						title="Used quantity (µg)"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (BioMaterialEventSource item : sources)
						{
							BioMaterial bm = null;
							ItemSubtype subtype = null;
							try
							{
								bm = item.getBioMaterial();
								subtype = bm.getItemSubtype();
							}
							catch (PermissionDeniedException ex)
							{}
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
									image="deleted.png" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=bm != null && bm.isRemoved()%>"
									/><%=Base.getLinkedName(ID, bm, bm == null, true)%></tbl:cell>
								<tbl:cell column="type">
									<%
									if (subtype != null)
									{
										%>
										<%=Base.getLinkedName(ID, subtype, false, true)%> <span class="itemsubtype">(<%=bm.getType() %>)</span>
										<%
									}
									else
									{
										%>
										<%=bm != null ? bm.getType() : "" %>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="quantity"><%=Values.formatNumber(item.getUsedQuantity(), 2)%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(bm == null ? "" : bm.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
					</tbl:rows>
					</tbl:data>
					</tbl:table>
					<%
				}
			%>
			</base:section>
			<%
			SpecialQuery<BioMaterialEventSource> childQuery = extract.getChildCreationEvents();
			childQuery.join(Hql.innerJoin("es", "event", "evt", true));
			childQuery.join(Hql.leftJoin("evt", "bioMaterial", "bm", null, true));
			childQuery.join(Hql.leftJoin("evt", "physicalBioAssay", "pba", null, true));
			childQuery.order(Orders.asc(Hql.property("pba", "name")));
			childQuery.order(Orders.asc(Hql.property("bm", "name")));
			ResultList<BioMaterialEventSource> children = childQuery.list(dc);
			%>
			<base:section 
				id="childSection" 
				title="<%="Child items (" + children.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (children.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No child items have been created from this extract
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table 
						id="children"
						columns="all"
						>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="type"
							title="Type"
						/>
						<tbl:columndef 
							id="quantity"
							title="Used quantity (µg)"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (BioMaterialEventSource item : children)
							{
								CommonItem child = null;
								ItemSubtype subtype = null;
								try
								{
									BioMaterialEvent evt = item.getEvent();
									if (evt.getEventType() == BioMaterialEvent.Type.BIOASSAY)
									{
										PhysicalBioAssay bioAssay = evt.getPhysicalBioAssay();
										subtype = bioAssay.getItemSubtype();
										child = bioAssay;
									}
									else
									{
										BioMaterial bm = evt.getBioMaterial();
										subtype = bm.getItemSubtype();
										child = bm;
									}
								}
								catch (PermissionDeniedException ex)
								{}
								%>
								<tbl:row>
									<tbl:cell column="name"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=child != null && child.isRemoved()%>"
										/><%=Base.getLinkedName(ID, child, child == null, true)%></tbl:cell>
									<tbl:cell column="type">
										<%
										if (subtype != null)
										{
											%>
											<%=Base.getLinkedName(ID, subtype, false, true)%> <span class="itemsubtype">(<%=child.getType() %>)</span>
											<%
										}
										else
										{
											%>
											<%=child != null ? child.getType() : "" %>
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="quantity"><%=Values.formatNumber(item.getUsedQuantity(), 2)%></tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(child == null ? "" : child.getDescription())%></tbl:cell>
								</tbl:row>
								<%
							}
							%>						
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this extract" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations &amp; parameters" 
				tooltip="View annotation values and protocol parameters" clazz="white">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			
			<t:tab id="events" title="Events" />

			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<%
				if ("overview".equals(tab))
				{
					%>
					<jsp:include page="../../common/overview/overview.jsp">
						<jsp:param name="item_type" value="<%=itemType.name()%>" />
						<jsp:param name="item_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>			
			</t:tabcontrol>


	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
