<%-- $Id: add_members_frameset.jsp 5961 2012-02-15 10:07:54Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
int bioMaterialListId = Values.getInt(request.getParameter("list_id"));
DbControl dc = sc.newDbControl();
String urlToController = "";
try
{
	BioMaterialList list = BioMaterialList.getById(dc, bioMaterialListId);
	Item memberType = list.getMemberType();
	if (memberType == Item.BIOSOURCE)
	{
		urlToController = "biosources";
	}
	else if (memberType == Item.SAMPLE)
	{
		urlToController = "samples";
	}
	else if (memberType == Item.EXTRACT)
	{
		urlToController = "extracts";
	}
}
finally
{
	if (dc != null) dc.close();
}
%>
	<base:page type="popup" title="Select biomaterial">
	<base:head>
	<script language="JavaScript">
	function addSelected()
	{
		var selected = top['members'].Table.getSelected(0);
		if (selected.length == 0)
		{
			alert('Please select at least one item in the list');
			return;
		}
		var frm = document.forms['addMembers'];
		frm.which.value = 'selected';
		Forms.createHidden(frm, 'items', selected.join(','));
		frm.submit();
	}
	function addCurrentPage()
	{
		var frm = document.forms['addMembers'];
		frm.which.value = 'page';
		frm.submit();
	}
	function addAll()
	{
		var frm = document.forms['addMembers'];
		frm.which.value = 'all';
		frm.submit();
	}
	</script>
	</base:head>
	<base:body>
		<h1>Select biomaterial</h1>
		
		<div id="f1" class="content"><iframe name="members" 
			src="../../<%=urlToController%>/index.jsp?ID=<%=ID%>&mode=selectmultiplenobuttons" 
			style="width: 100%; height: 100%;"></iframe></div>
			
		<base:buttongroup subclass="dialogbuttons topborder">
			<base:button title="Add selected" onclick="addSelected()" />
			<base:button title="Add current page" onclick="addCurrentPage()" />
			<base:button title="Add all" onclick="addAll()" />
			<base:button title="Close" onclick="window.top.close()" />
		</base:buttongroup>
			
		<form name="addMembers" action="index.jsp?ID=<%=ID%>" method="post" target="_top">
		<input type="hidden" name="cmd" value="AddMembers">
		<input type="hidden" name="list_id" value="<%=bioMaterialListId%>">
		<input type="hidden" name="which" value="">
		</form>
	</base:body>
</base:page>


