<%-- $Id: footnote.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page displays a short notice at the bottom of the
	screen.

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Message"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
String broadcastTitle = (String)application.getAttribute("broadcast.title");
SessionControl sc = Base.getSessionControl(pageContext, false);
String ID = "";
String serverAdminName = null;
String serverAdminEmail = null;
DbControl dc = null;
if (sc != null)
{
	ID = sc.getId();
	serverAdminName = Values.getStringOrNull(sc.getClientDefaultSetting("server.admin.name"));
	serverAdminEmail = Values.getStringOrNull(sc.getClientDefaultSetting("server.admin.email"));
	dc = sc.newDbControl();
}
long numNewMessages = 0;
try
{
	if (sc != null && sc.isLoggedIn()) numNewMessages = Message.countUnreadMessages(dc, null, false);
	%>
	<base:page type="popup" title="">
	<base:head styles="login.css">
	<script language="JavaScript">
	function readMessage(messageId)
	{
		Main.viewOrEditItem('<%=ID%>', 'MESSAGE', messageId, false);
		setTimeout('location.reload(true);', 1000);
	}
	function showMessages()
	{
		window.top['main'].location.href = getRoot()+'my_base/messages/index.jsp?ID=<%=ID%>';
	}
	function readBroadcast()
	{
		Main.openPopup('info/broadcast.jsp', 'BroadcastMessage', 450, 300);
	}
	</script>
	</base:head>
	<base:body onload="setTimeout('location.reload(true);', 60000);">
	<div class="footer">
	<table style="width: 100%; height: 100%;"><tr><td>
	<% 
	if (broadcastTitle != null)
	{
		String broadcastMessage = (String)application.getAttribute("broadcast.message");
		%>
		<div class="message">
		<b><a href="javascript:readBroadcast()" title="Read more">
				<base:icon image="warning.png" />&nbsp;<%=HTML.encodeTags(broadcastTitle) %></a></b>
		</div>
		<% 
	}
	else if (numNewMessages == 0)
	{
		%>
		<div class="credit">
			The development of BASE is currently supported by Lund
			University through SCIBLU. Previous patrons of the BASE project
			were the Knut and Alice Wallenberg Foundation and the Swedish
			Cancer Society.
			<% 
			if (serverAdminName != null) 
			{
				%>
				This server administered by: 
				<%
				if (serverAdminEmail != null)
				{
					%>
					<a href="mailto:<%=serverAdminEmail%>"><%=serverAdminName%></a>
					<%
				}
				else
				{
					%>
					<%=serverAdminName%>
					<%
				}
			}
			%>
		</div>
		<%
	}
	else if (numNewMessages == 1)
	{
		User user = User.getById(dc, sc.getLoggedInUserId());
		ItemQuery<Message> query = Message.getQuery(user);
		query.restrict(
			Restrictions.eq(
				Hql.property("read"),
				Expressions.parameter("read")
			)
		);
		query.setParameter("read", false, Type.BOOLEAN);
		ItemResultList<Message> messages = query.list(dc);
		Message message = messages.get(0);
		%>
		<base:icon image="message.png" tooltip="Read the message"
			onclick="<%="readMessage(" + message.getId() + ")"%>"
			>&nbsp;<%=HTML.encodeTags(message.getName())%> (From: <%=HTML.encodeTags(message.getFrom())%>)
		</base:icon>
		<%
	}
	else
	{
		%>
		<base:icon image="message.png" tooltip="Read the messages"
			onclick="showMessages()">&nbsp;<b>You have <%=numNewMessages%> new messages</b></base:icon>
		<%
	}
	%>
	</td></tr></table>
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
