<%-- $Id: view_plate.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PLATE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Plate plate = Plate.getById(dc, itemId);
	
	PlateMapping currentPlateMapping = null;
	try
	{
		currentPlateMapping = plate.getPlateMapping();
	}
	catch (PermissionDeniedException ex)
	{}
	
	final boolean writePermission = plate.hasPermission(Permission.WRITE);
	final boolean deletePermission = plate.hasPermission(Permission.DELETE);
	final boolean sharePermission = plate.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = plate.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = plate.isRemoved();
	final boolean isUsed = isRemoved && plate.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = plate.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, plate);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js,table.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'SharePlate', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 300);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 750, 500);
		}
		function viewWells()
		{
			location.href = 'wells/index.jsp?ID=<%=ID%>&plate_id=<%=itemId%>';
		}
		function viewEvents()
		{
			location.href = 'events/index.jsp?ID=<%=ID%>&plate_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'history' && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			} 
			else if (tabId == 'events')
			{
				viewEvents();
			}
			else if (tabId == 'wells')
			{
				viewWells();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Plates" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(plate.getName())%>" 
			/></p:path>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=plate.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						image="deleted.png"
						onclick="deleteItemPermanently()"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon image="used.png" 
						onclick="showUsingItems()"
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							onclick="editItem()" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this plate" : "You do not have permission to edit this plate"%>" 
						/>
						<tbl:button 
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							onclick="deleteItem()" 
							title="Delete"
							visible="<%=!plate.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this plate" : "You do not have permission to delete this plate"%>" 
						/>
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							onclick="restoreItem()" 
							title="Restore"
							visible="<%=plate.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this plate" : "You do not have permission to restore this plate"%>" 
						/>
						<tbl:button 
							disabled="<%=!sharePermission%>"
							image="share.png"
							onclick="shareItem()" 
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this plate to other user, groups and projects" : "You do not have permission to share this plate"%>"
						/>
						<tbl:button 
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							onclick="setOwner()" 
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							image="import.png" 
							onclick="runPlugin('ImportItem')" 
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							image="export.png" 
							onclick="runPlugin('ExportItem')" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							image="runplugin.png" 
							onclick="runPlugin('RunPlugin')" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							onclick="<%="Main.openHelp('" + ID +"', 'plate.view.properties')"%>"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(plate.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(plate.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Barcode</th>
				<td><%=HTML.encodeTags(plate.getBarcode())%></td>
			</tr>
			<tr>
				<th>Destroyed</th>
				<td><%=plate.isDestroyed() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<th>Type</th>
				<td><base:propertyvalue item="<%=plate%>" property="plateType" /></td>
			</tr>
			<tr>
				<th>Geometry</th>
				<td><base:propertyvalue item="<%=plate%>" property="plateType.plateGeometry" /></td>
			</tr>
			<tr>
				<th>Merge mapping</th>
				<td><%
					if (currentPlateMapping != null && currentPlateMapping.getImage() != null)
					{
						%>
						<img id="mappingImage" src="../../images/platemappings/<%=currentPlateMapping.getImage()%>" align="right">
						<%
					}
					%>
					<base:propertyvalue item="<%=plate%>" property="plateMapping" />
				</td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=plate%>" property="owner" /></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(plate)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(plate.getDescription())%></td>
			</tr>
			</table>
			</div>
			<%
			ItemQuery<Plate> parentPlatesQuery = plate.getParentPlates();
			parentPlatesQuery.include(Include.ALL);
			parentPlatesQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Plate> parentPlates = parentPlatesQuery.list(dc);
			%>
			<base:section
				id="parents"
				title="<%="Parent plates (" + parentPlates.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (parentPlates.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This plate doesn't have any parents (or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="parentplates"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="index"
						title="Index"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (Plate item : parentPlates)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="index"><%=plate.getSourceIndex(item)+1%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<%
			ItemQuery<Plate> childPlatesQuery = plate.getChildPlates();
			childPlatesQuery.include(Include.ALL);
			childPlatesQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Plate> childPlates = childPlatesQuery.list(dc);
			%>
			<base:section
				id="children"
				title="<%="Child plates (" + childPlates.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (childPlates.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This plate doesn't have any children (or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="childplates"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef
						id="mapping"
						title="Mapping"
					/>
					<tbl:columndef 
						id="index"
						title="Index"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (Plate item : childPlates)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="mapping"><base:propertyvalue item="<%=item%>" property="plateMapping" /></tbl:cell>
								<tbl:cell column="index"><%=item.getSourceIndex(plate) + 1%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this plate" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" clazz="white">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>

			<t:tab id="events" title="Events" />
			<t:tab id="wells" title="Wells" />
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
