<%-- $Id: view_project.jsp 5958 2012-02-14 10:26:51Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.core.Subtypable"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PROJECT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Project project = Project.getById(dc, itemId);
	
	final boolean usePermission = project.hasPermission(Permission.USE);
	final boolean writePermission = project.hasPermission(Permission.WRITE);
	final boolean deletePermission = project.hasPermission(Permission.DELETE);
	final boolean setOwnerPermission = project.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = project.isRemoved();
	final boolean isUsed = isRemoved && project.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = project.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, project);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 300);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 750, 500);
		}
		function setToActive()
		{
			Main.openPopup('set_active.jsp?ID=<%=ID%>&project_id=<%=itemId%>', 'ActivateProject', 300, 200);
		}
		function viewItems()
		{
			location.href = 'items/index.jsp?ID=<%=ID%>&project_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'items')
			{
				viewItems();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Projects" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(project.getName())%>" 
			/></p:path>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>" switch="switchTab">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="deleted.png"
						onclick="deleteItemPermanently()"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon image="used.png" 
						onclick="showUsingItems()"
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							onclick="editItem()" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this project" : "You do not have permission to edit this project"%>" 
						/>
						<tbl:button 
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							onclick="deleteItem()" 
							title="Delete"
							visible="<%=!project.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this project" : "You do not have permission to delete this project"%>" 
						/>
						<tbl:button 
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							onclick="restoreItem()" 
							title="Restore"
							visible="<%=project.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this project" : "You do not have permission to restore this project"%>" 
						/>
						<tbl:button 
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							onclick="setOwner()" 
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							onclick="setToActive()" 
							image="bullet.png"
							title="Set active"
							tooltip="Set this project to the active project"
						/>
						<tbl:button 
							image="import.png" 
							onclick="runPlugin('ImportItem')" 
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							image="export.png" 
							onclick="runPlugin('ExportItem')" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							image="runplugin.png" 
							onclick="runPlugin('RunPlugin')" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							onclick="<%="Main.openHelp('" + ID +"', 'project.view.properties')"%>"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(project.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(project.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=project%>" property="owner" /></td>
			</tr>
			<tr>
				<th>Default permissions</th>
				<td><base:propertyvalue item="<%=project%>" property="permissionTemplate" 
					nulltext="<%=PermissionUtil.getFullPermissionNames(project.getAutoPermission())%>" /></td>
			</tr>
			<tr>
				<th>Your permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(project)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(project.getDescription())%></td>
			</tr>
			</table>
			<%
			// Query to retrieve child groups
			ItemQuery<Group> groupQuery = project.getGroups();
			groupQuery.include(Include.ALL);
			groupQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Group> groups = groupQuery.list(dc);
			
			// Query to retrieve user members
			ItemQuery<User> userQuery = project.getUsers();
			userQuery.include(Include.ALL);
			userQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<User> users = userQuery.list(dc);
			int numMembers = groups.size() + users.size();
			%>
			<base:section
				id="membersSection"
				title="<%="Members (" + numMembers + ")"%>"
				context="<%=cc%>"
				>
				<%	
				if (numMembers == 0)
				{
					%>
					<div class="messagecontainer note">
					There are no members in this project
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="members"
						columns="all"
						>
						<tbl:columndef
							id="type"
							title="User/Group"
						/>
						<tbl:columndef
							id="name"
							title="Name"
						/>
						<tbl:columndef
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%					
						for (Group group : groups)
						{
							Set<Permission> permissions = project.getPermissions(group);
							%>
							<tbl:row>
								<tbl:cell column="type">Group</tbl:cell>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions"><%=permissions.toString().replaceAll("\\[|\\]", "")%></tbl:cell>
							</tbl:row>
							<%
						}
						for (User user : users)
						{
							Set<Permission> permissions = project.getPermissions(user);
							%>
							<tbl:row>
								<tbl:cell column="type">User</tbl:cell>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions"><%=permissions.toString().replaceAll("\\[|\\]", "")%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			%>
			</base:section>
			<%
			List<BasicItem> defaultItems = project.getDefaultItems(dc);
			%>
			<base:section 
				id="defaultSection" 
				title="Default items"
				context="<%=cc%>"
				>
				<%
				if (defaultItems.size() == 0 && project.getDefaultRawDataType() == null)
				{
					%>
					<div class="messagecontainer note">
					There are no default items in this project
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table 
						id="defaults"
						columns="all"
					>
					<tbl:columndef
						id="item"
						title="Item"
					/>
					<tbl:columndef
						id="type"
						title="Type"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>			
						<%
						if (project.getDefaultRawDataType() != null)
						{
							%>
							<tbl:row>
								<tbl:cell column="item"><%=project.getDefaultRawDataType().getName()%></tbl:cell>
								<tbl:cell column="type">Raw data type</tbl:cell>
							</tbl:row>
							<%
						}
						for (BasicItem item : defaultItems)
						{
							%>
							<tbl:row>
								<tbl:cell column="item"><base:propertyvalue item="<%=item%>" /></tbl:cell>
								<tbl:cell column="type">
									<%
									if (item instanceof Subtypable)
									{
										%>
										<base:propertyvalue item="<%=item%>" property="itemSubtype" nulltext="" /> (<%=item.getType()%>)
										<%
									}
									else
									{
										%>
										<%=item.getType()%>
										<%
									}
									%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this project" />
			</jsp:include>
		</t:tab>
			
		<t:tab id="items" title="Items" tooltip="List all items in this project" />
			
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
	dc.commit();
}
finally
{
	if (dc != null) dc.close();
}

%>
