<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.DERIVEDBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	DerivedBioAssay bioAssay = null;
	String title = null;
	
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;

	boolean readCurrentExtract = true;
	Extract currentExtract = null;

	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	
	boolean readCurrentHardware = true;
	Hardware currentHardware = null;
	
	boolean readCurrentSoftware = true;
	Software currentSoftware = null;

	ItemQuery<PhysicalBioAssay> physicalQuery = null;
	ItemQuery<DerivedBioAssay> parentQuery = null;
	
	Item parentType = null;
	
	if (itemId == 0)
	{
		title = "New derived bioassay";
		cc.removeObject("item");
		int parentId = Values.getInt(request.getParameter("parent_id"));
		int physicalBioAssayId = Values.getInt(request.getParameter("physicalbioassay_id"));
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		
		if (parentId != 0)
		{
			parentType = Item.DERIVEDBIOASSAY;
			DerivedBioAssay dba = DerivedBioAssay.getById(dc, parentId);
			parentQuery = DerivedBioAssay.getQuery();
			parentQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(parentId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, dba, Item.DERIVEDBIOASSAY);
			}
		}
		else if (physicalBioAssayId != 0)
		{
			parentType = Item.PHYSICALBIOASSAY;
			PhysicalBioAssay pba = PhysicalBioAssay.getById(dc, physicalBioAssayId);
			physicalQuery = PhysicalBioAssay.getQuery();
			physicalQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(physicalBioAssayId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, pba, Item.DERIVEDBIOASSAY);
			}
		}
		else if ("PHYISCALBIOASSAY".equals(request.getParameter("useParents")))
		{
			parentType = Item.PHYSICALBIOASSAY;
			physicalQuery = PhysicalBioAssay.getQuery();
			physicalQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			physicalQuery.setParameter("selected", sc.getCurrentContext(Item.PHYSICALBIOASSAY).getSelected(), Type.INT);
		}
		else if ("DERIVEDBIOASSAY".equals(request.getParameter("useParents")))
		{
			parentType = Item.DERIVEDBIOASSAY;
			parentQuery = DerivedBioAssay.getQuery();
			parentQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			parentQuery.setParameter("selected", cc.getSelected(), Type.INT);
		}

		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
	}
	else
	{
		bioAssay = DerivedBioAssay.getById(dc, itemId);
		bioAssay.checkPermission(Permission.WRITE);
		cc.setObject("item", bioAssay);
		title = "Edit bioassay -- " + HTML.encodeTags(bioAssay.getName());
		
		if (bioAssay.isRoot())
		{
			physicalQuery = bioAssay.getPhysicalBioAssays();
			parentType = Item.PHYSICALBIOASSAY;
		}
		else
		{
			parentQuery = bioAssay.getParents();
			parentType = Item.DERIVEDBIOASSAY;
		}
		
		try
		{
			currentSubtype = bioAssay.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentExtract = bioAssay.getExtract();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentExtract = false;
		}
		try
		{
			currentProtocol = bioAssay.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentHardware = bioAssay.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
		try
		{
			currentSoftware = bioAssay.getSoftware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSoftware = false;
		}
	}

	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	List<Hardware> defaultHardware = null;
	List<Software> defaultSoftware = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.PROTOCOL);
		defaultHardware = (List<Hardware>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.HARDWARE);
		defaultSoftware = (List<Software>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.SOFTWARE);
	}

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, currentSubtype);
	List<Software> recentSoftware = (List<Software>)cc.getRecent(dc, Item.SOFTWARE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioAssay);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,platforms.js,subtypes.js,ajax.js,json2.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "BioAssay" tab
		function validateBioAssay()
		{
			var frm = document.forms['bioAssay'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['bioAssay'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				if (dataFilesLoaded)
				{
					frames.datafiles.writeFileActionsToForm(frm);
				}
				if (frm.addedPhysicalBioAssays)
				{
					frm.addedPhysicalBioAssays.value = Link.getActionIds(1, 'P').join(',');
					frm.removedPhysicalBioAssays.value = Link.getActionIds(-1, 'P').join(',');
				}
				if (frm.addedParents)
				{
					frm.addedParents.value = Link.getActionIds(1, 'D').join(',');
					frm.removedParents.value = Link.getActionIds(-1, 'D').join(',');
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		var subtypeChanged = false;
		var dataFilesLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
				else if (tabId == 'datafiles' && (subtypeChanged || !dataFilesLoaded))
				{
					var subtypeId = ItemSubtype.getSubtypeId('bioAssay');
					Platforms.loadDataFilesFrame(frames.datafiles, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, 0, 0, subtypeId);
					dataFilesLoaded = true;
					subtypeChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['bioAssay'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}
		
		function getParents()
		{
			var frm = document.forms['bioAssay'];
			
			var parents = new Array();
			if (frm.physicalBioAssays && (!frm.isRoot || frm.isRoot[0].checked))
			{
				var ids = Link.getListIds(frm.physicalBioAssays, 'P');
				if (ids.length > 0)
				{
					parents[parents.length] = 'PHYSICALBIOASSAY:'+ids.join(':');
				}
			}
			else if (frm.parents && (!frm.isRoot || frm.isRoot[1].checked))
			{
				var ids = Link.getListIds(frm.parents, 'D');
				if (ids.length > 0)
				{
					parents[parents.length] = 'DERIVEDBIOASSAY:'+ids.join(':');
				}
			}
			var extractId = Math.abs(parseInt(frm.extract_id[frm.extract_id.selectedIndex].value));
			if (extractId > 0) parents[parents.length] = 'EXTRACT:'+extractId;
			return parents;
		}
		
		function subtypeOnChange()
		{
			var frm = document.forms['bioAssay'];
			var subtypeId = ItemSubtype.getSubtypeId('bioAssay');
			subtypeChanged = true;
			var recentInfo = ItemSubtype.getRecentAndRelatedInfo(subtypeId, 'BIOASSAY', ['PROTOCOL', 'HARDWARE', 'SOFTWARE']);
			protocolChanged = ItemSubtype.updateSelectionList(frm.protocol_id, recentInfo.PROTOCOL['recent'], recentInfo.PROTOCOL['default']);
			ItemSubtype.updateSelectionList(frm.hardware_id, recentInfo.HARDWARE['recent'], recentInfo.HARDWARE['default']);
			ItemSubtype.updateSelectionList(frm.software_id, recentInfo.SOFTWARE['recent'], recentInfo.SOFTWARE['default']);
		}

		
		function selectProtocolOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setProtocolCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'PROTOCOL');
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocol', 1050, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}
		
		function physicalBioAssayOnChange()
		{
			parentsChanged = true;
		}
		
		function parentBioAssayOnChange()
		{
			parentsChanged = true;
		}
		
		function selectHardwareOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setHardwareCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'HARDWARE');
			if (frm.hardware_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectHardware', 1050, 700);
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function selectSoftwareOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/software/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setSoftwareCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'SOFTWARE');
			if (frm.software_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.software_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectSoftware', 1050, 700);
		}
		function setSoftwareCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.software_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function selectExtractOnClick()
		{
			var frm = document.forms['bioAssay'];
			
			var relatedExtractIds = null;
			if (frm.physicalBioAssays && (!frm.isRoot || frm.isRoot[0].checked))
			{
				var ids = Link.getListIds(frm.physicalBioAssays, 'P');
				if (ids.length > 0)
				{
					var request = Ajax.getXmlHttpRequest();
					var url = '../physicalbioassays/ajax.jsp?ID=<%=ID%>&cmd=GetAllExtractIds';
					url += '&bioassay_ids=' + ids.join(',');
					request.open("GET", url, false); 
					request.send(null);
										
					var response = JSON.parse(request.responseText);
					if (response.status != 'ok')
					{
						alert(response.message);
						return null;
					}
					relatedExtractIds = response.allExtractIds;
				}
			}
			else if (frm.parents && (!frm.isRoot || frm.isRoot[1].checked))
			{
				var ids = Link.getListIds(frm.parents, 'D');
				if (ids.length > 0)
				{
					var request = Ajax.getXmlHttpRequest();
					var url = 'ajax.jsp?ID=<%=ID%>&cmd=GetAllExtractIds';
					url += '&bioassay_ids=' + ids.join(',');
					request.open("GET", url, false); 
					request.send(null);
										
					var response = JSON.parse(request.responseText);
					if (response.status != 'ok')
					{
						alert(response.message);
						return null;
					}
					relatedExtractIds = response.allExtractIds;
				}
			}

			var url = '../../biomaterials/extracts/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setExtractCallback&resetTemporary=1';
			if (relatedExtractIds) 
			{
				url += '&tmpfilter:INT:id='+relatedExtractIds.join('|');
			}
			url += ItemSubtype.createRelatedFilter('bioAssay', 'EXTRACT');
			if (frm.extract_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.extract_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectExtract', 1050, 700);
		}

		function setExtractCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.extract_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			extractOnChange();
		}
		
		function extractOnChange()
		{
			parentsChanged = true;
		}

		function addPhysicalBioAssayOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../physicalbioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple';
			url += '&callback=addPhysicalBioAssayCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'PHYSICALBIOASSAY');
			Main.openPopup(url, 'AddPhysicalBioAssay', 1050, 700);
		}
		
		function addPhysicalBioAssayCallback(pbaId, name)
		{
			var frm = document.forms['bioAssay'];
			var item = Link.getItem('P', pbaId);
			if (!item) item = new Item('P', pbaId, name);
			Link.addItem(frm.physicalBioAssays, item);
			parentsChanged = true;
		}

		function removePhysicalBioAssayOnClick()
		{
			Link.removeSelected(document.forms['bioAssay'].physicalBioAssays);
			parentsChanged = true;
		}

		
		function addParentOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = 'index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple';
			url += '&callback=addParentCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'DERIVEDBIOASSAY');
			Main.openPopup(url, 'AddParentBioAssay', 1050, 700);
		}
		
		function addParentCallback(dbaId, name)
		{
			var frm = document.forms['bioAssay'];
			var item = Link.getItem('D', dbaId);
			if (!item) item = new Item('D', dbaId, name);
			Link.addItem(frm.parents, item);
			parentsChanged = true;
		}

		function removeParentOnClick()
		{
			Link.removeSelected(document.forms['bioAssay'].parents);
			parentsChanged = true;
		}

		
		function init()
		{
			var frm = document.forms['bioAssay'];
			<%
			if (bioAssay == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initParents();
			initPhysicalBioAssays();
			if (frm.isRoot) 
			{
				isRootOnChange();
			}
		}
		
		function initPhysicalBioAssays()
		{
			var physicalBioAssays = document.forms['bioAssay'].physicalBioAssays;
			<%
			if (physicalQuery != null)
			{
				physicalQuery.include(Include.ALL);
				physicalQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<PhysicalBioAssay> physicalBioAssays = physicalQuery.list(dc);
				for (PhysicalBioAssay pba : physicalBioAssays)
				{
					if (bioAssay != null)
					{
						%>
						Link.addNewItem(physicalBioAssays, new Item('P', <%=pba.getId()%>, '<%=HTML.javaScriptEncode(pba.getName())%>'));
						<%
					}
					else
					{
						%>
						Link.addItem(physicalBioAssays, new Item('P', <%=pba.getId()%>, '<%=HTML.javaScriptEncode(pba.getName())%>'));
						<%
					}
				}
			}
			%>
		}
		
		function initParents()
		{
			var parents = document.forms['bioAssay'].parents;
			<%
			if (parentQuery != null)
			{
				parentQuery.include(Include.ALL);
				parentQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<DerivedBioAssay> parents = parentQuery.list(dc);
				for (DerivedBioAssay dba : parents)
				{
					if (bioAssay != null)
					{
						%>
						Link.addNewItem(parents, new Item('D', <%=dba.getId()%>, '<%=HTML.javaScriptEncode(dba.getName())%>'));
						<%
					}
					else
					{
						%>
						Link.addItem(parents, new Item('D', <%=dba.getId()%>, '<%=HTML.javaScriptEncode(dba.getName())%>'));
						<%
					}
					if (parents.size() == 1 && currentExtract == null)
					{
						try
						{
							currentExtract = dba.getExtract();
						}
						catch (PermissionDeniedException ex)
						{}
					}
				}
			}
			%>
		}
		
		function isRootOnChange()
		{
			var frm = document.forms['bioAssay'];
			var isRoot = frm.isRoot[0].checked;
			Main.showHide('physicalBioAssaySection', isRoot);
			Main.showHide('parentBioAssaySection', !isRoot);
		}

		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioAssay" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		
		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && bioAssay != null%>" 
			switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Bioassay" validate="validateBioAssay()" helpid="derivedbioassay.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(bioAssay == null ? Values.getString(cc.getPropertyValue("name"), "New derived bioassay") : bioAssay.getName())%>" 
					maxlength="<%=DerivedBioAssay.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>

			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						onchange="subtypeOnChange()"
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && bioAssay != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<%
			if (bioAssay == null)
			{
				%>
				<tr>
					<th>Parent type</th>
					<td>
						<input id="isRoot" type="radio" name="isRoot" value="1" 
							<%=parentType == Item.PHYSICALBIOASSAY ? "checked" : "" %>
							onchange="isRootOnChange()"><label for="isRoot">Physical bioassay</label>
						<input id="isChild" type="radio" name="isRoot" value="0"
							<%=parentType != Item.PHYSICALBIOASSAY ? "checked" : "" %>
							onchange="isRootOnChange()"><label for="isChild">Derived bioassay</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<%
			if (bioAssay == null || bioAssay.isRoot())
			{
				%>
				<tr id="physicalBioAssaySection">
					<th class="subprompt">- physical bioassays</th>
					<td>
						<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="physicalBioAssays" size="4" multiple onchange="physicalBioAssayOnChange()">
							</select>
						</td>
						<td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									subclass="leftaligned"
									style="width: 12em;"
									onclick="addPhysicalBioAssayOnClick()" 
									title="Add&nbsp;bioassays&hellip;" 
									tooltip="Add physical bioassays"
								/>
								<base:button 
									subclass="leftaligned"
									style="width: 12em;"
									onclick="removePhysicalBioAssayOnClick()" 
									title="Remove" 
									tooltip="Remove the selected physical bioassays"
								/>
							</base:buttongroup>
							<input type="hidden" name="addedPhysicalBioAssays" value="">
							<input type="hidden" name="removedPhysicalBioAssays" value="">
						</td>
						</tr>
						</table>
						</div>
					</td>
					<td></td>
				</tr>
				<%
			}
			if (bioAssay == null || !bioAssay.isRoot())
			{
				%>
				<tr id="parentBioAssaySection">
					<th class="subprompt">- bioassays</th>
					<td>
						<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="parents" size="4" multiple onchange="parentsOnChange()">
							</select>
						</td>
						<td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									subclass="leftaligned"
									style="width: 12em;"
									onclick="addParentOnClick()" 
									title="Add&nbsp;bioassays&hellip;" 
									tooltip="Add parent derived bioassays"
								/>
								<base:button 
									subclass="leftaligned"
									style="width: 12em;"
									onclick="removeParentOnClick()" 
									title="Remove" 
									tooltip="Remove the selected derived bioassays"
								/>
							</base:buttongroup>
							<input type="hidden" name="addedParents" value="">
							<input type="hidden" name="removedParents" value="">
						</td>
						</tr>
						</table>
						</div>
						
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Extract</th>
				<td>
					<base:select 
						id="extract_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentExtract%>"
						denied="<%=!readCurrentExtract%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectExtractOnClick()"
						onchange="extractOnChange()"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Hardware</th>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						defaultitems="<%=defaultHardware%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectHardwareOnClick()"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Software</th>
				<td>
					<base:select 
						id="software_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentSoftware%>"
						denied="<%=!readCurrentSoftware%>"
						recent="<%=recentSoftware%>"
						defaultitems="<%=defaultSoftware%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectSoftwareOnClick()"
					/>
				</td>
				<td></td>
			</tr>

			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(bioAssay == null ? cc.getPropertyValue("description") : bioAssay.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'bioAssay', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit"><iframe 
			name="datafiles" id="idDatafiles" src="../../common/datafiles/wait.jsp" 
			style="width: 100%; height: 100%;"></iframe></t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit"><iframe 
			name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
			style="width: 100%; height: 100%;"></iframe></t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" 
			helpid="annotations.edit.inherited"><iframe 
				name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				style="width: 100%; height: 100%;"></iframe></t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (bioAssay == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
