
<%@page import="net.sf.basedb.core.IntensityTransform"%><%-- $Id: index.jsp 6040 2012-03-30 08:22:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.BioAssaySetUtil"
	import="net.sf.basedb.util.DynamicFilter"
	import="net.sf.basedb.util.IncludeExcludeFilter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Collections"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,spots,reporters,date,tools");
	private static final Item itemType = Item.BIOASSAYSET;
	
	
	private void setClosed(HttpServletRequest request, ItemContext cc)
	{
		String closed = request.getParameter("closed");
		if (closed == null && cc.getSetting("closed") != null && cc.getObject("closed") == null)
		{
			closed = (String)cc.getSetting("closed");
		}
		if (closed != null)
		{
			cc.setSetting("closed", closed);
			cc.setObject("closed", new HashSet<String>(Arrays.asList(closed.split(","))));
		}
	}
%>
<%
final int experimentId = Values.getInt(request.getParameter("experiment_id"));
final String transformationId = request.getParameter("transformation_id");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_bioassaysets.jsp?ID="+ID+"&experiment_id="+experimentId
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_bioassayset.jsp?ID="+ID+"&experiment_id="+experimentId;
final String editPage = "edit_bioassayset.jsp?ID="+ID+"&experiment_id="+experimentId;
final String viewTransformationPage = "../transformations/view_transformation.jsp?ID="+ID+
	"&experiment_id="+experimentId;
final String newPage = "../../../common/plugin/index.jsp?ID="+ID
	+"&cmd=SelectPlugin&main_type=INTENSITY&item_type=BIOASSAYSET&context_type=LIST&title=Create+root+bioassay+set";

if (experimentId != 0) sc.getCurrentContext(Item.EXPERIMENT).setId(experimentId);

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		setClosed(request, cc);
		if (transformationId != null)
		{
			forward = viewTransformationPage;
		}
		else if (itemId != null)
		{
			forward = viewPage;
		}
		else
		{
			redirect = listPage;
		}
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		setClosed(request, cc);
		if (transformationId != null)
		{
			forward = viewTransformationPage;
		}
		else if (itemId != null)
		{
			forward = viewPage;
		}
		else
		{
			redirect = listPage;
		}
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		if (transformationId != null)
		{
			forward = viewTransformationPage;
		}
		else if (itemId != null)
		{
			forward = viewPage;
		}
		else
		{
			redirect = listPage;
		}
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		redirect = newPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		
		BioAssaySet bas = (BioAssaySet)cc.getObject("item");
		if (bas != null)
		{
			dc = sc.newDbControl();
			dc.reattachItem(bas, false);
			message = "Bioassay set updated";

			JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.BIOASSAYSET), bas);
			ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
			try
			{
				bas.setName(Values.getStringOrNull(request.getParameter("name")));
				bas.setDescription(Values.getStringOrNull(request.getParameter("description")));
				bas.setIntensityTransform(IntensityTransform.valueOf(request.getParameter("intensityTransform")));
	
				// Annotations tab
				Base.updateAnnotations(dc, bas, bas, request);
				
				// OnSave extensions
				invoker.render(OnSaveRenderer.ON_SAVE);
				dc.commit();
				invoker.render(OnSaveRenderer.ON_COMMIT);
			}
			catch (Exception ex)
			{
				invoker.render(OnSaveRenderer.onRollback(ex));
				throw ex;
			}
			finally
			{
				cc.removeObject("item");
			}
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.removeRecursively(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		ItemContext tc = sc.getCurrentContext(Item.TRANSFORMATION);
		ItemContext xc = sc.getCurrentContext(Item.EXTRAVALUE);
		setClosed(request, cc);

		int numTotal = cc.getSelected().size()+tc.getSelected().size();
		int numRemoved = 0;
		int[] numTransformationRemoved = RemovableUtil.removeRecursively(dc, Item.TRANSFORMATION, tc.getSelected(), true);
		int[] numBioAssaySetRemoved = RemovableUtil.removeRecursively(dc, itemType, cc.getSelected(), true);
		int numXV = RemovableUtil.delete(dc, Item.EXTRAVALUE, xc.getSelected());
		numTotal += numTransformationRemoved[1] + numBioAssaySetRemoved[1];
		numRemoved += numTransformationRemoved[0] + numBioAssaySetRemoved[0];

		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		if (transformationId != null)
		{
			forward = viewTransformationPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
		else if (itemId != null)
		{
			forward = viewPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
		else
		{
			redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.removeRecursively(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		ItemContext tc = sc.getCurrentContext(Item.TRANSFORMATION);
		setClosed(request, cc);

		int numTotal = cc.getSelected().size()+tc.getSelected().size();
		int numRemoved = 0;
		int[] numTransformationRemoved = RemovableUtil.removeRecursively(dc, Item.TRANSFORMATION, tc.getSelected(), false);
		int[] numBioAssaySetRemoved = RemovableUtil.removeRecursively(dc, itemType, cc.getSelected(), false);
		numTotal += numTransformationRemoved[1] + numBioAssaySetRemoved[1];
		numRemoved += numTransformationRemoved[0] + numBioAssaySetRemoved[0];
		
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		if (transformationId != null)
		{
			forward = viewTransformationPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
		else if (itemId != null)
		{
			forward = viewPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
		else
		{
			redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
		}
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		setClosed(request, cc);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final ItemQuery<BioAssaySet> query = experiment.getBioAssaySets();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+bioassay+sets";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+bioassay+set";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		setClosed(request, cc);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final ItemQuery<BioAssaySet> query = experiment.getBioAssaySets();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+bioassay+sets";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+bioassay+set";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		setClosed(request, cc);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final ItemQuery<BioAssaySet> query = experiment.getBioAssaySets();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run a plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunAnalysisPlugin".equals(cmd))
	{
		// Run an analysis plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=ANALYZE&title=Run+analysis+plugin";
	}
	else if ("NewFilteredBioAssaySet".equals(cmd))
	{
		// Display the edit page for for filtering a bioassay set (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=ANALYZE&title=Filter+bioassay+set&plugin_type=net.sf.basedb.core.plugin.AnalysisFilterPlugin";
	}
	else if ("SetClosedWithAjax".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		setClosed(request, cc);
		return;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

