<%-- $Id: plotter.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http:// base.thep.lu.se/

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final float scale = Base.getScale(sc);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	final int bioAssaySetId = Values.getInt(request.getParameter("bioAssaySetId"));
	final int reporterIndex = Values.getInt(request.getParameter("reporterIndex"));
	final int positionIndex = Values.getInt(request.getParameter("positionIndex"));
	final String plotType = Values.getString(request.getParameter("type"), "assay");
	final int annotationTypeId = Values.getInt(request.getParameter("annotationTypeId"));
	final boolean needAverageMethod = positionIndex == ExperimentExplorer.SPOT_AVG;
	
	final BioAssaySet bas = BioAssaySet.getById(dc, bioAssaySetId);
	final RawDataType rdt = bas.getRawDataType();
	final Experiment experiment = bas.getExperiment();
	final int maxRawMappings = bas.getMaxRawMappingsForSpot();
	final IntensityTransform transform = bas.getIntensityTransform();
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bas);
	final ReporterData reporter = explorer.getReporter(dc, reporterIndex);
	final List<AnnotationType> annotationTypes = explorer.getAnnotationTypes(dc, true);
	
	List<TableColumn> formulas = new LinkedList<TableColumn>();
	DynamicUtil.addSpotColumns(formulas, dc, rdt.getChannels(), transform);
	DynamicUtil.addFormulaColumns(formulas, dc, rdt, Formula.Type.COLUMN_EXPRESSION, 
			transform, "", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(formulas, dc, bas, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(formulas, dc, rdt, "", "", "[Raw] ");
	}
	
	StringBuilder formulaOptions = new StringBuilder();
	for (TableColumn tc : formulas)
	{
		if (tc.getJepExpression() != null && tc.getDatatype().isNumerical())
		{
			if (!needAverageMethod || tc.getAverageMethod() != Formula.AverageMethod.NONE)
			{
				String jepExpression = tc.getJepExpression();
				addFormulaOption(formulaOptions, jepExpression, tc.getTitle(), tc.getDescription());
			}
		}
	}
	
	String title = HTML.encodeTags("Plot " + bas.getName());
	final boolean hasCreateFilePermission = sc.hasPermission(Permission.CREATE, Item.FILE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head styles="tabcontrol.css" scripts="tabcontrol.js">
	<script language="JavaScript">

	var averageMethods = new Array();
	<%
	for (TableColumn tc : formulas)
	{
		if (tc.getJepExpression() != null && tc.getDatatype().isNumerical())
		{
			if (!needAverageMethod || tc.getAverageMethod() != Formula.AverageMethod.NONE)
			{
				%>
				averageMethods[averageMethods.length] = '<%=tc.getAverageMethod().name()%>';
				<%
			}
		}
	}
	%>
	
	function validate()
	{
		var frm = document.forms['plot'];
		if (Main.trimString(frm.yFormula.value) == '')
		{
			alert("You must enter an expression for the Y axis");
			frm.yFormula.focus();
			return false;
		}
		return true;
	}
	
	function getPlotType()
	{
		var frm = document.forms['plot'];
		return Forms.getCheckedRadio(frm.plotType).value;
	}

	function plotTypeOnChange()
	{
		var plotType = getPlotType();
		var frm = document.forms['plot'];
		var isAssayPlot = plotType == 'assay';
		frm.annotationTypeId.disabled = isAssayPlot;
		frm.subtype.disabled = !isAssayPlot;
	}
	
	function presetOnChange(list, formula, label)
	{
		var index = list.selectedIndex;
		var frm = list.form;
		if (frm.averageMethod)
		{
			var avgMethod = averageMethods[index-1];
			Forms.selectListOption(frm.averageMethod, avgMethod);
		}
		formula.value = list[index].value;
		if (label && list[index].value != '') label.value = list[index].text;
		list.selectedIndex = 0;
	}
		
	function generatePlotUrl(fullSize)
	{
		if (validate())
		{
			var frm = document.forms['plot'];
			var url = getRoot() + 'views/experiments/explorer/plot';
			url += '?ID=<%=ID%>&bioAssaySetId=<%=bioAssaySetId%>';
			url += '&reporterIndex=<%=reporterIndex%>&positionIndex=<%=positionIndex%>';
			url += '&title='+Main.encodeURI(frm.title.value);
			url += '&subTitle='+Main.encodeURI(frm.subTitle.value);
			if (fullSize)
			{
				url += '&width='+frm.width.value;
				url += '&height='+frm.height.value;
			}
			
			url += '&y='+Main.encodeURI(frm.yFormula.value);
			url += '&yLog='+(frm.yLog.checked ? 1 : 0);
			url += '&yLabel='+Main.encodeURI(frm.yLabel.value);
			
			var plotType = getPlotType();
			url += '&type='+plotType;
			url += '&showXLabels='+(frm.hideXLabels.checked ? 0 : 1);
			
			if (plotType == 'assay')
			{
				url += '&subtype=' + frm.subtype[frm.subtype.selectedIndex].value;
				if (frm.averageMethod)
				{
					url += '&averageMethod=' + frm.averageMethod[frm.averageMethod.selectedIndex].value;
				}
			}
			else if (plotType == 'annotation')
			{
				url += '&annotationTypeId=' + frm.annotationTypeId[frm.annotationTypeId.selectedIndex].value;
			}
			url += '&' + new Date().getTime();
			return url;
		}
	}
	
	function openExpressionBuilder(title, frmName, inputName, formulaType)
	{
		if (!document.forms[frmName][inputName].disabled)
		{
			var restrictions = formulaType == '<%=Formula.Type.COLUMN_RESTRICTION.name()%>';
			Main.expressionBuilder('<%=ID%>', title, frmName, inputName, formulaType, '<%=rdt.getId()%>', <%=rdt.getChannels()%>, restrictions, <%=bas.getId()%>);
		}
	}
	
	function previewPlot()
	{
		var url = generatePlotUrl(false);
		if (url)
		{
			url += '&width=540&height=360';

			var overlayImg = document.getElementById('overlay');
			overlayImg.src = getRoot()+'images/plot_generating.gif';
			
			var previewImg = document.getElementById('preview');
			previewImg.realImg = new Image();
			previewImg.realImg.onload = changePreviewImage;
			previewImg.realImg.src = url;
		}
	}
	
	function changePreviewImage()
	{
		var previewImg = document.getElementById('preview');
		previewImg.src = previewImg.realImg.src;
		previewImg.realImg = null;
		var overlayImg = document.getElementById('overlay');
		overlayImg.src = getRoot() + 'images/blankbutton.gif';
	}
	
	function viewPlot()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			var frm = document.forms['plot'];
			var width = parseInt(frm.width.value);
			var height = parseInt(frm.height.value);
			if (!width || width < 600) width = 600;
			if (!height || height < 400) height = 400;
			Main.openPopup('../../plotter/view.jsp?ID=<%=ID%>&title='+Main.encodeURI(frm.title.value), 'ViewPlot', width+150, height+100);
		}
	}
	
	function downloadPlot()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			Main.openPopup('../../plotter/download.jsp?ID=<%=ID%>', 'DownloadPlot', 300, 200);
		}
	}
	
	function savePlotAs()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			Main.openPopup('../../plotter/save_as.jsp?ID=<%=ID%>', 'SavePlotAs', 450, 300);
		}
	}
	
	function init()
	{
		plotTypeOnChange();
	}
	</script>
	</base:head>
	<base:body onload="init()">
	<h1><%=title%> <base:help helpid="explorer.plotter" /></h1>
	<form name="plot">
	<div class="content bottomborder">
		<div class="absolutefull rightborder" style="right: 550px;">
	
			<table class="fullform input100 smaller">
			<tbody>
			<tr>
				<th>Plot title</th>
				<td colspan="2"><input type="text" class="text" maxlength="255" name="title" 
					value="<%=HTML.encodeTags(bas.getName())%>"></td>
			</tr>
			<tr>
				<th class="subprompt">Subtitle</th>
				<td colspan="2"><input type="text" class="text" maxlength="255" name="subTitle" 
					value="<%=HTML.encodeTags(reporter.getName())%>"></td>
			</tr>
				<tr>
					<th>Width</th>
					<td colspan="2"><input type="text" class="text" style="width: 10em;" maxlength="10" name="width" 
						value="900" onkeypress="return Numbers.integerOnly(event)"> (not used by preview)</td>
				</tr>
				<tr>
					<th>Height</th>
					<td colspan="2"><input type="text" class="text" style="width: 10em;" maxlength="10" name="height" 
						value="600" onkeypress="return Numbers.integerOnly(event)"></td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			
			<tbody class="simplesection">
				<tr>
					<th>Y-axis</th>
					<td>
					<select name="yPresets" style="width: 25em;"
						onchange="presetOnChange(this, this.form.yFormula, this.form.yLabel)" 
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="yFormula"></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('Y-axis expression', 'plot', 'yFormula', 'COLUMN_EXPRESSION')"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabel"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLog">Log scale</label></th>
					<td><input type="checkbox" name="yLog" id="yLog" value="1"></td>
					<td></td>
				</tr>
				<%
				if (positionIndex == ExperimentExplorer.SPOT_AVG)
				{
					%>
					<tr>
						<th class="subprompt">Average method</td>
						<td>
							<select name="averageMethod">
							<%
							for (Formula.AverageMethod method : Formula.AverageMethod.values())
							{
								if (method != Formula.AverageMethod.NONE)
								{
									%>
									<option value="<%=method.name()%>"><%=method.toString()%></option>
									<%
								}
							}
							%>
							</select>
						</td>
						<td></td>
					</tr>
					<%	
				}
				%>
				<tr>
					<th>X-axis</th>
					<td>
						<input type="radio" name="plotType" value="assay" onchange="plotTypeOnChange()"
							id="plotTypeAssay" <%=plotType.equals("assay") ? "checked" : ""%>
							><label for="plotTypeAssay"
							title="Creates a line/bar plot with bioassays along the x axis">Bioassays</label>
						<input type="radio" name="plotType" value="annotation" onchange="plotTypeOnChange()"
							id="plotTypeAnnotation" <%=plotType.equals("annotation") ? "checked" : ""%>
							><label for="plotTypeAnnotation" 
							title="Creates a box plot with annotation values along the x axis">Annotation</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Annotation</td>
					<td>
						<select name="annotationTypeId" class="selectionlist">
						<%
						for (AnnotationType at : annotationTypes)
						{
							String selected = at.getId() == annotationTypeId ? "selected" : "";
							%>
							<option value="<%=at.getId()%>" <%=selected%>><%=HTML.encodeTags(at.getName())%>
							<%
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="hideXLabels">No labels</label></th>
					<td><input type="checkbox" name="hideXLabels" id="hideXLabels" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>Plot type</th>
					<td>
						<select name="subtype">
						<option value="line">Line plot</option>
						<option value="bar">Bar plot</option>
						</select>
					<td></td>
				</tr>
			</tbody>

			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>

		</div>
		<div class="absolutefull filled" style="width: 550px; left: auto;">
			<img src="../../../../images/plot_empty.png" id="preview" 
				style="position: absolute; top: 5px; z-index: 1;">
			<img src="../../../../images/plot_select.png" id="overlay" 
				style="position: absolute; top: 5px; z-index: 2;">
		</div>
	
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button title="Preview" onclick="previewPlot()" 
			image="plotter_preview.png" tooltip="Generate a preview of the plot" 
		/>
		<base:button title="View&hellip;" onclick="viewPlot()" 
			image="plotter.png" tooltip="View a fullsized version of the plot (in a popup)" 
		/>
		<base:button title="Download&hellip;" onclick="downloadPlot()" 
			image="download.png"
			tooltip="Downlad a fullsized version of the plot to your computer" 
		/>
		<base:button title="Save as&hellip;" onclick="savePlotAs()" 
			image="saveas.png"
			disabled="<%=!hasCreateFilePermission%>"
			tooltip="<%=hasCreateFilePermission ? 
				"Save a fullsized version of the plot on the BASE server" :
				"You don't have permission to create files" %>" 
		/>
		<base:button onclick="window.close()" title="Close" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
