<%-- $Id: list_spotdata.jsp 5952 2012-02-10 12:27:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.DynamicSpotQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ColorGenerator"
	import="net.sf.basedb.util.formatter.LookupFormatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.ArrayList"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Arrays"
	import="java.awt.Color"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.SPOTDATA;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int bioAssayId = Values.getInt(request.getParameter("bioassay_id"));
final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("spot data", "spot data");
final DbControl dc = sc.newDbControl();
DynamicResultIterator spotData = null;
try
{
	final BioAssay bioAssay = bioAssayId == 0 ? null : BioAssay.getById(dc, bioAssayId);
	final BioAssaySet bioAssaySet = bioAssay != null ? bioAssay.getBioAssaySet() : BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final int experimentId = experiment.getId();
	final RawDataType rawDataType = bioAssaySet.getRawDataType();
	final IntensityTransform transform = bioAssaySet.getIntensityTransform();
	
	final String subContext = rawDataType.getId();
	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	List<TableColumn> columns = new LinkedList<TableColumn>();
	DynamicUtil.addSpotColumns(columns, dc, rawDataType.getChannels(), transform);
	DynamicUtil.addFormulaColumns(columns, dc, rawDataType, Formula.Type.COLUMN_EXPRESSION, 
			transform, "frm.", "[Formula] ", true);
	DynamicUtil.addExtraColumns(columns, dc, bioAssaySet, "ev", "#", "[Xtra] ");
	DynamicUtil.addRawDataColumns(columns, dc, rawDataType, "raw.", "$", "[Raw] ");
	DynamicUtil.addReporterColumns(columns, dc, experiment.getVirtualDb().getReporterCloneTemplate(), "rep.", "@", "[Rep] ");
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, columns, false);
	if (bioAssay == null && cc.getSetting("columns").indexOf("COLUMN") >= 0) 
	{
		selected.selectedIds.add("COLUMN");
		selected.selectedProperties.add("COLUMN");
	}
	try
	{
		final DynamicSpotQuery query = bioAssay != null ? bioAssay.getSpotData() : bioAssaySet.getSpotData();
		cc.configureQuery(dc, query, selected.selectedProperties);
		query.setFailSafe(true);
		spotData = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}

	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, 
		guiContext, bioAssay == null ? bioAssaySet : bioAssay);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker overviewPlotInvoker = bioAssay != null ? 
		null : ExtensionsControl.useExtensions(jspContext, "net.sf.basedb.clients.web.bioassayset.overviewplots");
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'spotdata';
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 750, 500);
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties.bioassay')
			{
				location.href = '../bioassays/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=bioAssayId%>&tab=properties';
			}
			else if (tabId == 'annotations.bioassay')
			{
				location.href = '../bioassays/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=bioAssayId%>&tab=annotations';
			}
			else if (tabId == 'properties.bioassayset')
			{
				location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=bioAssaySetId%>&tab=properties';
			}
			else if (tabId == 'annotations.bioassayset')
			{
				location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=bioAssaySetId%>&tab=annotations';
			}
			else if (tabId == 'overviewplots')
			{
				location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&cmd=ViewItem&experiment_id=<%=experimentId%>&item_id=<%=bioAssaySetId%>&tab='+tabId;
			}
			else if (tabId == 'bioassays')
			{
				location.href = '../bioassays/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>&bioassayset_id=<%=bioAssaySetId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 600, 400);
		}
		</script>
	</base:head>
	<base:body>
		<p:path>
			<p:pathelement 
				title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" 
			/><%
			if (bioAssay == null)
			{
				%><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				/><%
			}
			else
			{
				%><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
					href="<%="../bioassays/index.jsp?ID="+ID+"&bioassayset_id="+bioAssaySet.getId()%>" 
				/><p:pathelement title="<%=HTML.encodeTags(bioAssay.getName())%>" 
				/><%
			}
			%></p:path>

		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content"
			active="spotdata" switch="switchTab">
		<t:tab id="properties.bioassay" title="Properties" visible="<%=bioAssay != null%>"/>
		<t:tab id="properties.bioassayset" title="Properties" visible="<%=bioAssay == null%>"/>

		<t:tab id="annotations.bioassay" title="Annotations" 
			tooltip="View annotation values" visible="<%=bioAssay != null%>" />
		<t:tab id="annotations.bioassayset" title="Annotations" 
				tooltip="View annotation values" visible="<%=bioAssay == null%>" />

		<t:tab id="bioassays" visible="<%=bioAssay == null%>" title="BioAssays" />
		<t:tab id="spotdata" title="Spot data" >
		<tbl:table 
			id="spotdata" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<tbl:hidden 
				name="bioassay_id" 
				value="<%=String.valueOf(bioAssayId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<%
			for (TableColumn tc : columns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					property="<%=tc.getProperty()%>"
					tooltip="<%=tc.getDescription()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=HTML.encodeTags(tc.getTitle())%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%=tc.getShow()%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
			<%
			if (bioAssay == null)
			{
				Map<Number, String> bioAssayMap = new HashMap<Number, String>();
				Enumeration<String, String> bioAssayEnum = new Enumeration<String, String>();
				for (BioAssay ba : bioAssaySet.getBioAssays().list(dc))
				{
					short columnNo = ba.getDataCubeColumnNo();
					String linkedBioAssay = Base.getLinkedName(ID, ba, false, true);
					// Safety measure, since JDBC driver seems to return 'short' as 'int'
					bioAssayMap.put(columnNo, linkedBioAssay);
					bioAssayMap.put((int)columnNo, linkedBioAssay);
					bioAssayEnum.add(String.valueOf(columnNo), HTML.encodeTags(ba.getName()));
				}
				%>
				<tbl:columndef
					id="COLUMN"
					property="COLUMN"
					datatype="int"
					title="Bioassay"
					sortable="true"
					filterable="true"
					exportable="true"
					enumeration="<%=bioAssayEnum%>"
					formatter="<%=new LookupFormatter<Number>(bioAssayMap)%>"
				/>
				<%
			}
			%>
			<tbl:columndef 
				id="reporterList"
				property="£reporterList"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						image="add.png"
						onclick="newReporterList()"
						title="New reporter list&hellip;"
						tooltip="Create a new reporter list from matching spots"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
					/>
					<tbl:button 
						image="export.png" 
						onclick="runPlugin('ExportItems')" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=spotData == null ? 0 : spotData.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header 
							clazz="index"
							colspan="2"
						/>
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header 
							clazz="index"
							colspan="2"
						/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (spotData != null)
					{
						while (spotData.hasNext())
						{
							SqlResult item = spotData.next();
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								<%
								int i = 1;
								for (String columnId : selected.selectedIds)
								{
									%>
									<tbl:cell column="<%=columnId%>" value="<%=item.getObject(i++)%>" />
									<%
								}
								%>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=spotData == null || spotData.getTotalCount() == 0 ? "No spot data were found" : "No spot data on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
		</tbl:table>
		</t:tab>

		<t:tab id="overviewplots" title="Overview plots"
			visible="<%=overviewPlotInvoker != null && overviewPlotInvoker.getNumExtensions() > 0%>" 
		/>
		</t:tabcontrol>

		<base:buttongroup>
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
