<%-- $Id: edit_reporterlist.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.REPORTERLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	String name = null;
	ReporterList reporterList = null;
	boolean addReporters = false;
	boolean mergeReporterLists = false;
	int numSelectedLists = cc.getSelected().size();
	String formId = request.getParameter("formId");
	String fromContext = Values.getString(request.getParameter("fromContext"), "REPORTER");
	String subContext = request.getParameter("subContext");

	if (itemId == 0)
	{
		title = "Create reporter list";
		cc.removeObject("item");
		addReporters = Values.getBoolean(request.getParameter("addReporters"));
		mergeReporterLists = !addReporters && numSelectedLists > 0;
		name = request.getParameter("name");
		if (name == null) name = Values.getString(cc.getPropertyValue("name"), "New reporter list");
	}
	else
	{
		reporterList = ReporterList.getById(dc, itemId);
		name = reporterList.getName();
		cc.setObject("item", reporterList);
		title = "Edit reporter list -- " + HTML.encodeTags(reporterList.getName());
	}
	if (reporterList != null) reporterList.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), reporterList);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Reporter list" tab
		function validateReporterList()
		{
			var frm = document.forms['reporterList'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.minCount)
			{
				var checked = Forms.getCheckedRadio(frm.create);
				if (checked.value == 'count')
				{
					if (!Numbers.isInteger(frm.minCount.value))
					{
						alert('You must specify the number of reporter lists');
						frm.count.focus();
						return false;
					}
					else
					{
						var minCount = parseInt(frm.minCount.value);
						if (minCount < 1 || minCount > <%=numSelectedLists%>)
						{
							alert('You must specify between 1 and <%=numSelectedLists%>');
							frm.count.focus();
							return false;
						}
					}
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['reporterList'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (frm.which) Forms.createHidden(frm, 'items', getSelectedItems().join(','));
				frm.submit();
			}
		}
		
		function init()
		{
			var frm = document.forms['reporterList'];
			<%
			if (reporterList == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			if (frm.which && getSelectedItems().length == 0)
			{
				frm.which[0].disabled = true;
				var lblSelected = document.getElementById('lblSelected');
				lblSelected.disabled = true;
				Main.addClass(lblSelected, 'disabled');
			}
		}
		// Get the ID:s of all selected reorters
		var selectedItems = new Array();
		var hasCheckSelectedItems = false;
		function getSelectedItems()
		{
			<%
			if (formId != null)
			{
				%>
				if (!hasCheckSelectedItems)
				{
					selectedItems = window.opener.Table.getSelected('<%=formId%>');
					hasCheckedSelectedItems = true;
				}
				<%
			}
			%>
			return selectedItems;
		}
		function checkRadio(radio, name)
		{
			Forms.checkRadio(radio, name);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="reporterList" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="fromContext" value="<%=fromContext%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=reporterList != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Reporter list" 
			validate="validateReporterList()" helpid="reporterlist.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=ReporterList.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(reporterList == null ? Values.getString(cc.getPropertyValue("externalId")) : reporterList.getExternalId())%>" 
					maxlength="<%=ReporterList.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (addReporters)
			{
				%>
				<tr>
					<th>Which reporters?</th>
					<td>
						<input type="radio" name="which" id="whichSelected" value="selected"
							><label for="whichSelected" id="lblSelected">Selected items</label><br>
						<input type="radio" name="which" id="whichPage" value="page"
							><label for="whichPage">Current page</label><br>
						<input type="radio" name="which" id="whichAll" value="all" checked
							><label for="whichAll">All pages</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			else if (mergeReporterLists)
			{
				%>
				<tr>
					<th>Add reporters?</th>
					<td>
						<input type="radio" name="create" id="createEmpty" value=""
							><label for="createEmpty"
							title="The new reporter list will be empty">No</label><br>
						<input type="radio" name="create" id="createUnion" value="union" checked
							><label for="createUnion" 
								title="The new reporter list contains all reporters from the selected lists"
								>Union of selected lists</label> 
								<base:icon image="set_operations/union_small.png" /><br>
						<input type="radio" name="create" id="createIntersection" value="intersection"
							><label for="createIntersection" 
								title="The new reporter lists contains only reporters that are present in ALL selected lists"
								>Intersection of selected lists</label> 
								<base:icon image="set_operations/intersection_small.png" /><br>
						<input type="radio" name="create" id="createCount" value="count"
							><label for="createCount"
								title="The new reporter lists contains only reporters that are present in some of selected lists"
								>Present in at least</label>
							<input type="text" class="text" name="minCount" size="2" maxlength="2"
								value="1"
								onkeypress="return Numbers.integerOnly(event)"
								onfocus="checkRadio(document.forms['reporterList'].create, 'count');">
							of the selected lists (1-<%=numSelectedLists%>).
							<br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" 
						><%=HTML.encodeTags(reporterList == null ? cc.getPropertyValue("description") : reporterList.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'reporterList', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
